/* -*- Mode: C++; tab-width: 8; indent-tabs-mode: nil; c-basic-offset: 2 -*-
 *
 *  USBSink - clientdispatcher.cc
 *
 *  Copyright (C) 2006 Marko Anastasov
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include "clientdispatcher.h"
#include <glib.h>

namespace USBSink
{

namespace TaskHandling
{

using std::vector;

std::auto_ptr<ClientDispatcher> ClientDispatcher::instance_;

ClientDispatcher*
ClientDispatcher::instance()
{
  if (! instance_.get())
    instance_.reset(new ClientDispatcher());

  return instance_.get();
}

ClientDispatcher::ClientDispatcher()
{
}

ClientDispatcher::~ClientDispatcher()
{
}

void
ClientDispatcher::add_client(SharedWaitingClient& client)
{
  clients_.push_back(client);
}

void
ClientDispatcher::get_clients(vector<SharedWaitingClient>& ret_clients)
{
  ret_clients.assign(clients_.begin(), clients_.end());

  clients_.clear();
}

} // namespace TaskHandling

} // namespace USBSink
